	.686p
	.MMX
	.XMM
	.model flat, stdcall


	includelib kernel32.lib
	includelib user32.lib
	includelib gdi32.lib
	includelib shell32.lib
	includelib comdlg32.lib
	includelib Z:\MASM_Projects\Traicer\2Ex\bpint3dbg.lib

	include C:\masm32\include\windows.inc
	include C:\masm32\include\kernel32.inc
	include C:\masm32\include\user32.inc
	include C:\masm32\include\gdi32.inc
	include C:\masm32\include\shell32.inc
	include C:\masm32\include\comdlg32.inc
	
	EXTERN		_imp__BreaknEnter:dword
	LoadPE equ	_imp__BreaknEnter	

	PEDBG struc
	  pri PROCESS_INFORMATION <>
	  ImageBase dd ?
	  EPointRVA dd ?
	  EPointVA dd ?
	  OldProtect dd ?
	  NewProtect dd ?
	  OldByte db ?
	PEDBG ends
	
	
szText MACRO Name, Text:VARARG
  LOCAL lbl
    jmp lbl
      Name db Text,0
    lbl:
  ENDM
  
hInst equ 400000h
uFLAGS equ OFN_EXPLORER+OFN_FILEMUSTEXIST+OFN_HIDEREADONLY+OFN_PATHMUSTEXIST+OFN_LONGNAMES

;#########################################################################

.data
  Buffer db 100h dup(0)
  App db 'Traicer',0
  FilterStr	db 'EXE',0,'*.EXE',0
		db 'ALL',0,'*.*',0,0
  maska db 'Executed %lu (dec) instructions, EIP = %0.8X',0
  ofn OPENFILENAME <>
  
  bp_count dd 0
  InstDone dd 1
  rEIP dd 0
  i db 0
  current_opcode db 0

.data?
  pPEDBG dd ? ; PROCESS_INFORMATION
  dbg DEBUG_EVENT <>
  align dword
  cont CONTEXT <>
  
  Report db 500h dup(?)

.code

start:
  mov ofn.lStructSize, 4Ch
  mov ofn.lpstrFilter, offset FilterStr
  mov ofn.lpstrFile, offset Buffer
  mov ofn.nMaxFile, 100h
  mov ofn.Flags, uFLAGS
  invoke GetOpenFileName, addr ofn
  
  .if eax
    push offset Buffer
    call LoadPE
    mov pPEDBG, eax
    .if eax
      .while TRUE
        invoke WaitForDebugEvent, addr dbg, INFINITE
        .if dbg.dwDebugEventCode == EXCEPTION_DEBUG_EVENT
        mov cont.ContextFlags, CONTEXT_CONTROL
          
          .if dbg.u.Exception.pExceptionRecord.ExceptionCode == EXCEPTION_BREAKPOINT
            mov esi, pPEDBG
            inc bp_count
            
            .if bp_count != 1
              invoke GetThreadContext, [esi.PEDBG.pri.hThread], addr cont
              mov eax, cont.regEip
              dec eax
              .if eax == [esi.PEDBG.EPointVA]
                ; WE ARE STOPPED ON ENTRYPOINT
                mov rEIP, eax
                invoke VirtualProtectEx,[esi.PEDBG.pri.hProcess],\
                [esi.PEDBG.EPointVA],1,PAGE_EXECUTE_READWRITE,addr [esi.PEDBG.OldProtect]
                invoke WriteProcessMemory,[esi.PEDBG.pri.hProcess],\
                [esi.PEDBG.EPointVA],addr [esi.PEDBG.OldByte],1,addr i
                invoke VirtualProtectEx,[esi.PEDBG.pri.hProcess],\
                [esi.PEDBG.EPointVA],1,[esi.PEDBG.OldProtect],addr [esi.PEDBG.NewProtect]
                dec cont.regEip
                or cont.regFlag, 100h
                invoke SetThreadContext, [esi.PEDBG.pri.hThread], addr cont
                invoke ContinueDebugEvent,dbg.dwProcessId,dbg.dwThreadId,DBG_CONTINUE
                .continue
              .endif
            .else ; IF IT IS THE 1st SYSTEM BP
              nop
              invoke ContinueDebugEvent,dbg.dwProcessId,dbg.dwThreadId,DBG_CONTINUE
              .continue
            .endif
            
          .elseif dbg.u.Exception.pExceptionRecord.ExceptionCode == EXCEPTION_SINGLE_STEP
            inc InstDone
            invoke GetThreadContext, [esi.PEDBG.pri.hThread], addr cont
            or cont.regFlag, 100h
            invoke SetThreadContext, [esi.PEDBG.pri.hThread], addr cont
            invoke ContinueDebugEvent,dbg.dwProcessId,dbg.dwThreadId,DBG_CONTINUE
            .continue
          .endif
          
        .elseif dbg.dwDebugEventCode == EXIT_PROCESS_DEBUG_EVENT
         .break
          
        .endif
        invoke ContinueDebugEvent,dbg.dwProcessId,dbg.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
      .endw
    .endif
  .endif
  
  invoke wsprintf, addr Buffer, addr maska, InstDone, rEIP
  invoke MessageBox, 0, addr Buffer, addr App, 0
  invoke ExitProcess,0

end start
;#########################################################################

00401000 >   EB 04          JMP SHORT Traicer.00401006
00401002     EB 05          JMP SHORT Traicer.00401009
00401004     8901           MOV DWORD PTR DS:[ECX],EAX
00401006     E8 FBFFFFFF    CALL Traicer.00401006
0040100B     05 27314000    ADD EAX,Traicer.00403127
00401010     0831           OR BYTE PTR DS:[ECX],DH
00401012     40             INC EAX

